import peasy.*;

PeasyCam cam;

PVector pRay = new PVector(0, 0, 0);
PVector pRayDir = new PVector(0.8, .7, 1);

PVector sphereCenter = new PVector(100, 100, 100);
float sphereRadius = 60;

void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);
}

void draw()
{
  background(0);

  coordSys(100);

  // draw sphere
  fill(255);
  noStroke();
  pushMatrix();
  translate(sphereCenter.x,sphereCenter.y,sphereCenter.z);
  sphere(sphereRadius);
  popMatrix();
  
  // draw ray
  stroke(255, 255, 0);
  drawRay(pRay,pRayDir);

  // check if the ray hits the triangle
  PVector hit1 = new PVector();
  PVector hit2 = new PVector();

  if(sphereIntersection(pRay, 
                        pRayDir, 
                        sphereCenter, sphereRadius, 
                        hit1,hit2) >= 1)
  {
    strokeWeight(15);
    stroke(255, 0, 0);
    point(hit1.x, hit1.y, hit1.z);
    point(hit2.x, hit2.y, hit2.z);
    strokeWeight(1);
  }
}

